#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int k = 0;
    while ((1 << (k + 1)) - 1 < n) k++;

    sort(a.begin(), a.end());
    vector<int> srt = a;
    srt.resize(unique(all(srt)) - srt.begin());
    for (auto& el : a) el = lower_bound(all(srt), el) - srt.begin();

    int real_n = 1 << k;
    vector<int> cnt(real_n);
    for (int i = 0; i < n; i++) {
        if (a[i] >= real_n) {
            cout << -1 << '\n';
            return 0;
        }
        cnt[a[i]]++;
    }

    vector<int> tree(n, -1);
    vector<set<int>> lvl(k + 1);
    lvl[0].insert(0);

    auto add = [&](auto self, int i, int v, int d) -> void {
        lvl[d].erase(v);
        tree[v] = i;
        if (v >= real_n - 1) return;

        if (tree[2 * v + 1] == -1) {
            self(self, i, 2 * v + 1, d + 1);
        } else {
            self(self, i, 2 * v + 2, d + 1);
        }

        if (tree[2 * v + 2] == -1) {
            lvl[d + 1].insert(2 * v + 2);
        }
    };

    for (int i = 0; i < real_n; i++) {
        int need = k + 1 - cnt[i];
        if (need < 0 || need > k || lvl[need].empty()) {
            cout << -1 << '\n';
            return 0;
        }
        add(add, i, *lvl[need].begin(), need);
    }

    for (int i = real_n - 1; i < n; i++) cout << srt[tree[i]] << " \n"[i == n - 1];

    return 0;
}