#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include<sstream>
using namespace __gnu_pbds;
using namespace std;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

#define maxI 2147483647
#define minI -2147483648
#define maxLL 9223372036854775807
#define minLL -9223372036854775808

mt19937 gen;
int ran(int n) {
    return uniform_int_distribution<int>(0, n - 1)(gen);
}

typedef long long ll;
typedef long double ld;

int l, r, u, d;
int cnt;
vector<vector<bool>> used(10, vector<bool> (10, true));
vector<vector<char>> mp(10, vector<char> (10));

void dfs(int x, int y) {
    l = min(l, x);
    r = max(r, x);
    u = min(y, u);
    d = max(y, d);
    cnt++;
    used[x][y] = false;
    if (x > 0 && mp[x - 1][y] == '#' && used[x - 1][y])
        dfs(x - 1, y);
    if (y > 0 && mp[x][y - 1] == '#' && used[x][y - 1])
        dfs(x, y - 1);
    if (x + 1 < 10 && mp[x + 1][y] == '#' && used[x + 1][y])
        dfs(x + 1, y);
    if (y + 1 < 10 && mp[x][y + 1] == '#' && used[x][y + 1])
        dfs(x, y + 1);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);cout.tie(nullptr);
    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            cin >> mp[i][j];
        }
    }
    for (int i = 0; i < 9; i++) {
        for (int j = 0; j < 9; j++) {
            if (mp[i][j] == '#' && mp[i + 1][j + 1] == '#') {
                cout << "NO\n";
                return 0;
            }
        }
    }
    for (int i = 0; i < 9; i++) {
        for (int j = 1; j < 10; j++) {
            if (mp[i][j] == '#' && mp[i + 1][j - 1] == '#') {
                cout << "NO\n";
                return 0;
            }
        }
    }
    vector<int> a(4, 0);
    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            if (used[i][j] && mp[i][j] == '#') {
                l = i; r = i;
                u = j; d = j;
                cnt = 0;
                dfs(i, j);
                int n = r - l + 1;
                int m = d - u + 1;
                if (cnt != n * m || min(n, m) != 1 || max(n, m) > 4) {
                    cout << "NO\n";
                    return 0;
                }
                a[max(m, n) - 1]++;
            }
        }
    }
    if (a[0] == 4 && a[1] == 3 && a[2] == 2 && a[3] == 1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    return 0;
}
