#include <bits/stdc++.h>

using namespace std;

map<int, int> mp;
vector<vector<char>> matrix(10, vector<char> (10));

vector<pair<int, int>> step_check{{1, 1}, {1, -1}, {-1, 1}, {-1, -1}};
vector<pair<int, int>> step_y{{0, 1}, {0, -1}};
vector<pair<int, int>> step_x{{1, 0}, {-1, 0}};

bool check_x(int x, int y){
    if(matrix[x][y] != '#') return 0;

    for(int h= 0; h < 2; h++){
        int i= x + step_x[h].first;
        int j= y + step_x[h].second;

        if(-1 < i && i < 10 && -1 < j && j < 10){
            if(matrix[i][j] == '#') return 0;
        }
    }

    return 1;
}

bool check_y(int x, int y){
    if(matrix[x][y] != '#') return 0;

    for(int h= 0; h < 2; h++){
        int i= x + step_y[h].first;
        int j= y + step_y[h].second;

        if(-1 < i && i < 10 && -1 < j && j < 10){
            if(matrix[i][j] == '#') return 0;
        }
    }

    return 1;
}

int main (){

    for(int i= 0; i < 10; i++){
        for(int j= 0; j < 10; j++)
            cin >> matrix[i][j];
    }

    for(int i= 0; i < 10; i++){
        for(int j= 0; j < 10; j++){
            for(int h= 0; h < 4; h++){
                int x= i + step_check[h].first;
                int y= j + step_check[h].second;

                if(-1 < x && x < 10 && -1 < y && y < 10){
                    if(matrix[i][j] == '#' && matrix[x][y] == '#'){
                        cout << "NO";
                        return 0;
                    }
                }
            }
        }
    }

///////
    for(int i= 0; i < 10; i++){
        int cnt= 0;
        for(int j= 0; j < 10; j++){
            if(check_x(i, j)) cnt++;
            else{
                mp[cnt]++;
                cnt= 0;
            }
        }
    }


    for(int i= 0; i < 10; i++){
        int cnt= 0;
        for(int j= 0; j < 10; j++){
            if(check_y(j, i)) cnt++;
            else{
                mp[cnt]++;
                cnt= 0;
            }
        }

        mp[cnt]++;
    }


    if(mp[1] != 8 || mp[2] != 3 || mp[3] != 2 || mp[4] != 1
       || mp[5] != 0 || mp[7] != 0 || mp[8] != 0 || mp[9] != 0 || mp[10] != 0 ){
        cout << "NO";
        return 0;
    }

    cout << "YES";
}
