#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("03")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi2,fma")


#define int long long
#define double long double

#define set unordered_set

vector<set<int>> mas3;

vector<vector<int>> ans;

void dfs(int u){
    ans.back().push_back(u);
    if(mas3[u].size() == 0){
        return;
    }
    int x = *mas3[u].begin();
    mas3[u].erase(x);
    mas3[x].erase(u);
    dfs(x);
}

signed main() {
#ifdef sjbody
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    //cout << setprecision(8) << fixed;

    int n, m, k;
    cin >> n >> m >> k;
    vector <vector <int>> mas1(n), mas2(n);
    for (int i = 0; i < m; i ++)
    {
        int a, b;
        cin >> a >> b;
        a --;
        b --;
        mas1[a].push_back(b);
        mas1[b].push_back(a);
    }

    for (int i = 0; i < k; i ++)
    {
        int a, b;
        cin >> a >> b;
        a --;
        b --;
        mas2[a].push_back(b);
        mas2[b].push_back(a);
    }

    mas3.resize(n);
    for (int i = 0; i < n; i ++)
    {
        for (int j = 0; j < mas1[i].size(); j ++)
        {
            mas3[i].insert(mas1[i][j]);
        }
        for (int j = 0; j < mas2[i].size(); j ++)
        {
            if (mas3[i].count(mas2[i][j]) == 0)
            {
                mas3[i].insert(mas2[i][j]);
            }
            else
            {
                mas3[i].erase(mas2[i][j]);
            }
        }
    }

    vector <vector <int>> mas(n);
    for (int i = 0; i < n; i ++)
    {
        for (auto j = mas3[i].begin(); j != mas3[i].end(); j ++)
        {
            mas[i].push_back(*j);
        }
    }


    bool flag = true;
    for (int i = 0; i < n; i ++)
    {
        if (mas[i].size() % 2 == 1)
        {
            flag = false;
            break;
        }
    }

    if (flag)
    {
        cout << "YES" << '\n';
        for(int i = 0; i < n; i++){
            //cout << "aaaaaaaa\n";
            while(mas3[i].size() > 0) {
                ans.push_back({});
                dfs(i);
                if(ans.back().size() == 0){
                    ans.pop_back();
                }else{
                    ans.back().pop_back();
                }
            }
        }
        /*
        for(auto i : ans){
            for(auto j : i){
                cout << j << " ";
            }
            cout << endl;
        }
        */

        int count = 0;
        vector <pair <int, pair <int, int>>> fff;
        for (int i = 0; i < ans.size(); i ++)
        {
            for (int j = 0; j < ans[i].size() - 2; j ++)
            {
                fff.push_back({ans[i][j], {ans[i][j + 1], ans[i][ans[i].size() - 1]}});
            }
        }

        cout << fff.size() << '\n';
        for (int i = 0; i < fff.size(); i ++)
        {
            cout << fff[i].first + 1 << " " << fff[i].second.first + 1 << " " << fff[i].second.second + 1 << '\n';
        }
    }
    else
    {
        cout << "NO" << '\n';
    }

    return 0;
}