#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//#define int ll

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define many int _; cin >> _; while(_--)

vector<int> h, c;

ll get(int l, int r) { // [l; r]
    if (l == r) {
        return c[l];
    }
    if (l > r) {
        return 0;
    }
    int ind = l;
    for (int i = l + 1; i <= r; i++) {
        if (h[i] > h[ind]) {
            ind = i;
        }
    }
    ll res_l = get(l, ind - 1), res_r = get(ind + 1, r);
    ll ans = c[ind] + min(res_l, res_r);
    return ans;
}

int main() {
    int n;
    cin >> n;
    h.resize(n);
    for (auto &i : h) {
        cin >> i;
    }
    c.resize(n);
    for (auto &i : c) {
        cin >> i;
    }

    ll ans = get(0, n - 1);
    cout << ans;
}
