field = []
for i in range(12):
    field.append([0] * 12)
for i in range(10):
    l = input()
    for j in range(10):
        if l[j] == '#':
            field[i + 1][j + 1] = 1
        else:
            field[i + 1][j + 1] = 0
neigh_cnt = [4, 12, 4]

'''
#.#.#.....
.......##.
.#..#.....
.#........
.#..##....
..........
####...#..
.......#..
.......#..
##........
'''

def check_diag(field, x, y):
    return (field[x - 1][y - 1] + field[x + 1][y - 1] + field[x - 1][y + 1] + field[x + 1][y + 1])

def check_main(field, x, y):
    return (field[x - 1][y] + field[x + 1][y] + field[x][y - 1] + field[x][y + 1])

ans = "YES"

found_four = 2

for h in range(1, 11):
    for w in range(1, 11):
        if field[h][w] == 1:
            if check_diag(field, h, w):
                ans = "NO"
            else:
                neighbours = check_main(field, h, w)
                if neighbours > 2:
                    ans = "NO"
                else:
                    if (check_main(field, h, w) == 2):
                        a = check_main(field, h - 1, w) == 2
                        b = check_main(field, h + 1, w) == 2
                        c = check_main(field, h, w + 1) == 2
                        d = check_main(field, h, w - 1) == 2
                        if (a or b or c or d):
                            found_four -= 1
                    neigh_cnt[neighbours] -= 1
if (neigh_cnt[0] == 0 and neigh_cnt[1] == 0 and neigh_cnt[2] == 0 and found_four == 0):
    print(ans)
else:
    print("NO")
