#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> all;
    set<int> unique;
    for (int i = 0; i < n; ++i) {
        int element;
        cin >> element;

        all.push_back(element);
        unique.insert(element);
    }

    int uniquePredictSize = (n + 1) / 2;
    if (uniquePredictSize != unique.size()) {
        cout << "-1";
        return 0;
    }

    sort(all.begin(), all.end());

    int minElement = all.at(0);
    int minElementAmount = 0;
    for (int i = 0; i < n; ++i) {
        if (all.at(i) == minElement) {
            minElementAmount++;
        }
    }

    for (int element: unique) {
        if (element == all.at(0)) continue;

        int amount = 0;
        for (int j = 0; j < n; ++j) {
            if (all.at(j) == element) {
                amount++;
            }
        }

        if (amount >= minElementAmount) {
            cout << "-1";
            return 0;
        }
    }

    for (int element: unique) {
        cout << element << " ";
    }

    return 0;
}
