#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 7;
unordered_set <int> g[N];
unordered_set <int> non_empty;

void invert(int u, int v) {
    if (g[u].find(v) != g[u].end()) {
        g[u].erase(v);
        g[v].erase(u);
        if (g[u].empty()) {
            non_empty.erase(u);
        }
        if (g[v].empty()) {
            non_empty.erase(v);
        }
    } else {
        g[u].insert(v);
        g[v].insert(u);
        non_empty.insert(u);
        non_empty.insert(v);
    }
}

void invert(int a, int b, int c) {
    invert(a, b);
    invert(b, c);
    invert(a, c);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m + k; i++) {
        int v, u;
        cin >> v >> u;
        invert(v, u);
    }
    vector <tuple <int, int, int>> ans;
    while (!non_empty.empty()) {
        int v = *non_empty.begin();
        if ((int) g[v].size() == 1) {
            cout << "NO\n";
            return 0;
        }
        auto uk = g[v].begin();
        int u1 = *(uk++);
        int u2 = *uk;
        invert(v, u1, u2);
        ans.emplace_back(v, u1, u2);
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto [a, b, c] : ans) {
        cout << a << ' ' << b << ' ' << c << '\n';
    }
    return 0;
}