#include <iostream>
#include <algorithm>

typedef long long ll;

const ll big = (ll)1e18 + 1;
const int N = 200000;
int h[N], c[N];

ll dp[N];

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    
    int n;
    std::cin >> n;
    for (int i = 0; i < n; ++i) {
        std::cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> c[i];
    }

    std::fill(dp, dp + n, big);
    for (int i = 0; i < n; i++) {
        for (int j = i; j >= 0; j--) {
            if (h[j] <= h[i]) {
                dp[i] = std::min(dp[i], c[i] + (j == 0 ? 0 : dp[j - 1]));
            } else {
                break;
            }
        }
        ll val = c[i] + (i == 0 ? 0 : dp[i - 1]);
        for (int j = i + 1; j < n; j++) {
            if (h[j] <= h[i]) {
                dp[j] = std::min(dp[j], val);
            } else {
                break;
            }
        }
    }
    std::cout << dp[n - 1] << "\n";
}