#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

double pw(double a, int n, double res) {
    if (n == 0) return res;
    if (n % 2) return pw(a, n - 1, res * a);
    return pw(a * a, n / 2, res);
}

int main() {
    int n, m1;
    cin >> n >> m1;
    double r;
    cin >> r;
    vector <int> d(n), w(n);
    vector < vector <int> > a(n + 1, vector <int> (2));
    vector <double> dp(n + 1, 0);
    a[0][0] = 0;
    a[0][1] = 0;
    for (int i = 1; i <= n; i++) {
        cin >> a[i][0] >> a[i][1];
    }
    sort(a.begin(), a.end());
    for (int i = 1; i <= n; i++) {
        dp[i] = dp[i - 1] * pw(1 - r, a[i][0] - a[i - 1][0], 1) + r * a[i][1];
    }
    while (m1--) {
        int q;
        cin >> q;
        int l = 0, r1 = n + 1;
        while (r1 - l > 1) {
            int m = (r1 + l) / 2;
            if (a[m][0] <= q) {
                l = m;
            } else {
                r1 = m;
            }
            // cout << l << ' ' << a[m][0] << ' ' << r1 << endl;
        }
        // cout << l << endl;
        cout << setprecision(7) << dp[l] * pw(1 - r, q - a[l][0], 1) << '\n';
    }
}