#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

long long inf = 2e18, n;

long long mk_res(long long l, long long r) {
    if (l == -1 && r == n) return 0;
    if (l == -1) return 0;
    if (r == n) return n - 1;
    return (r + l) / 2;
}

long long res(long long l, long long r, long long i) {
    if (l == -1 && r == n) return inf;
    if (l == -1) return r - i;
    if (r == n) return i - l;
    return min(r - i, i - l);
}

int main() {
    int k;
    cin >> n >> k;
    set < vector <long long> > st;
    st.insert({inf, 1, n});
    vector < vector <long long> > q(k, vector <long long> (3));
    int u = 0;
    while (k--) {
        string s;
        cin >> s;
        if (s[0] == '-') {
            int j = -stoi(s) - 1;
            long long l = q[j][0], r = q[j][2];
            long long b = mk_res(l, q[j][1]), c = mk_res(q[j][1], r), d = mk_res(l, r);
            st.erase({res(l, q[j][1], b), -l, q[j][1]});
            st.erase({res(q[j][1], r, c), -q[j][1], r});
            st.insert({res(l, r, d), -l, r});
        } else {
            vector <long long> s = *st.rbegin();
            st.erase(--st.end());
            long long r = s[2], l = -s[1], ans = mk_res(l, r);
            long long b = mk_res(l, ans), c = mk_res(ans, r);
            // cout << l << ' ' << r << ' ' << ans << ' ' << b << ' ' << c << ' ' << res(l, ans, b) << ' ' << res(ans, r, c) << endl;
            st.insert({res(l, ans, b), -l, ans});
            st.insert({res(ans, r, c), -ans, r});
            cout << ans + 1 << '\n';
            q[u][0] = l;
            q[u][1] = ans;
            q[u][2] = r;
            u++;
        }
    }
}