#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    long double r;
    cin >> r;
    if (r == 0) {
        cout << 0;
        return 0;
    }
    vector<pair<int, int>> data(n);
    for (int i = 0; i < n; ++i)
        cin >> data[i].first >> data[i].second;
    sort(data.begin(), data.end());

    vector<pair<int, int>> days(m);
    for (int i = 0; i < m; ++i) {
        cin >> days[i].first;
        days[i].second = i;
    }
    sort(days.begin(), days.end());

    long double cur_w = 0;
    int p1 = 0, p2 = 0;
    cout.precision(30);
    for (int i = 1; i <= days.back().first; ++i) {
        if (data[p1].first == i) {
            cur_w += data[p1].second * r;
            ++p1;
        }
        if (days[p2].first == i) {
            cout << cur_w << ' ';
            ++p2;
        }
        cur_w *= (1 - r);
    }


    return 0;
}