#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include<sstream>

using namespace __gnu_pbds;
using namespace std;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

#define maxI 2147483647
#define minI -2147483648
#define maxLL 9223372036854775807
#define minLL -9223372036854775808

mt19937 gen;

int ran(int n) {
    return uniform_int_distribution<int>(0, n - 1)(gen);
}

typedef long long ll;
typedef long double ld;

struct sprs {
    vector<vector<pair<ll, ll>>> st;

    void init(int n, vector<pair<ll, ll>> &arr) {
        st.resize(__lg(n) + 3, vector<pair<ll, ll>>(n, {0, 0}));
        st[0] = arr;
        for (int lvl = 1; lvl <= __lg(n) + 1; ++lvl) {
            for (int l = 0; l + (1 << lvl) - 1 <= n; ++l) {
                st[lvl][l] = max(st[lvl - 1][l], st[lvl - 1][l + (1 << (lvl - 1))]);
            }
        }
    };

    pair<ll, ll> f(int l, int r) {
        r++;
        int k = __lg(r - l);
        pair<ll, ll> t = max(st[k][l], st[k][r - (1 << k)]);
        return t;
    }
};

ld pow2(ld a, ll b) {
    if (b == 1) {
        return a;
    }
    if (b == 0) {
        return 1;
    }
    ld x = pow2(a, b / 2);
    x *= x;
    if (b % 2 == 0) {
        return x;
    } else {
        return x * a;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    ld r;
    cin >> r;
    vector<pair<int, ld>> days(n);
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> days[i].first >> days[i].second;
        d[i] = days[i].first;
    }
    vector<int> req(m);
    for (auto &i : req) {
        cin >> i;
    }
    sort(days.begin(), days.end());
    sort(d.begin(), d.end());
    vector<pair<ld, ld>> waste(n);
    ld cur = 0;
    waste[0] = make_pair(0, r * days[0].second);
    for (int i = 1; i < n; i++) {
        waste[i].first = waste[i - 1].second * pow2((1 - r), (days[i].first - days[i - 1].first));
        waste[i].second = waste[i].first + days[i].second * r;
    }
    for (auto i : req) {
        auto it = lower_bound(d.begin(), d.end(), i);
        int pos;
        if (it == d.end()) {
            pos = n - 1;
        } else {
            if (*it == i) {
                pos = it - d.begin();
            } else {
                pos = it - d.begin() - 1;
            }
        }
        cout << fixed << setprecision(10);
        if (pos == -1) {
            cout << 0;
        } else {
            cout << waste[pos].second * pow2(1 - r, abs(d[pos] - i));
        }
        cout << '\n';
    }
    return 0;
}
