#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> mp;
vector<int> ans;

class segment_tree{
public:
    vector<int> tree;
    vector<int> add;

    segment_tree(int n){
        tree.resize(2 * n);
    }

    void build(int v, int tl, int tr){
        if(tl == tr){
            tree[v]= ans[tl];
            return;
        }

        int tm= (tl + tr) / 2;
        build(2 * v, tl, tm);
        build(2 * v + 1, tm + 1, tr);

        tree[v]= min(tree[2 * v], tree[2 * v + 1]);
    }
};

void recur(int l, int r, int itr){
    int i;
    if(itr < 1) return;
    //// 1
        i= (l + r + 1) / 2;
        ans[i]= mp[itr].back();
        mp[itr].pop_back();

    ////
        recur(l, (l + r) / 2, itr - 1);
        recur((l + r + 1) / 2, r, itr - 1);
}

int main () {
    int n;
    cin >> n;

    if(n == 1){
        int x;  cin >> x;
        cout << x;
        return 0;
    }

    int k= __lg(n + 1) - 1;
    mp.resize(k + 2);
    vector <int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    sort(a.begin(), a.end());

    int i= 0;
    while(i < n){
        int x= a[i];
        int j= 1;
        while(i + j < n && x == a[i + j]) j++;

        if(j > k + 1){
            cout << "-1";
            return 0;
        }
        mp[j].push_back(x);
        i+= j;
    }


    for(auto &x: mp){
        sort(x.begin(), x.end());
        reverse(x.begin(), x.end());
    }

    ans.resize(1 << k);

    if(mp[k + 1].size() != 1){
        cout << "-1";
        return 0;
    }

    for(int i= 0; i < k; i++){
        if(mp[k - i].size() != (1 << i)){
            cout << "-1";
            return 0;
        }
    }


    ans[0]= mp[k + 1][0];
    recur(0, (1 << k) - 1, k);

    segment_tree tr(1 << k);
    tr.build(1, 0, (1 << k) - 1);
    tr.tree[0]= INT_MIN;
    sort(tr.tree.begin(), tr.tree.end());

    for(int i= 0; i < n; i++){
        if(a[i] != tr.tree[i + 1]){
            //cout << i << " " << a[i] << " " << tr.tree[i + 1];
            cout << "-1";
            return 0;
        }
    }

    for(auto x: ans) cout << x << " ";
}
