#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

ld binpow(ld x, ll n) {
    if (n == 0) {
        return 1;
    }
    ld y = binpow(x, n / 2);
    if (n % 2 == 0) {
        return y * y;
    } else {
        return y * y * x;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    ld r;
    cin >> r;
    vector<pair<ll, ll>> q;
    for (int i = 0; i < n; ++i) {
        ll w, l;
        cin >> l >> w;
        q.emplace_back(l, w);
    }
    for (int i = 0; i < m; ++i) {
        ll l;
        cin >> l;
        q.emplace_back(l, -i);
    }
    std::sort(q.begin(), q.end(), [&](pair<ll, ll> &a, pair<ll, ll> & b) {
        return a.first < b.first || (a.first == b.first && a.second > b.second);
    });
    ll last = 0;
    ld x = 0;
    vector<ld> ans(m);
    for (auto &[l, w] : q) {
        x *= binpow(1 - r, l - last);
        if (w <= 0) {
            ans[-w] = x;
        } else {
            x += r * w;
        }
        last = l;
    }
    cout << fixed << setprecision(12);
    for (auto &i : ans) cout << i << ' ';

}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}
