#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//#define int ll

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define many int _; cin >> _; while(_--)



int main() {
    vector<vector<char>> a(12, vector<char>(12, '.'));
    for (int i = 1; i <= 10; i++) {
        for (int j = 1; j <= 10; j++) {
            cin >> a[i][j];
        }
    }
    for (int i = 1; i <= 10; i++) {
        for (int j = 1; j <= 10; j++) {
            if (a[i][j] == '#') {
                if (a[i][j] == a[i + 1][j + 1]) {
                    cout << "NO\n";
                    return 0;
                }
                if (a[i][j] == a[i - 1][j + 1]) {
                    cout << "NO\n";
                    return 0;
                }
                if (a[i][j] == a[i + 1][j - 1]) {
                    cout << "NO\n";
                    return 0;
                }
                if (a[i][j] == a[i - 1][j - 1]) {
                    cout << "NO\n";
                    return 0;
                }
            }
        }
    }
    vector<vector<int>> dp(12, vector<int>(12, 0));
    for (int i = 1; i <= 10; i++) {
        for (int j = 1; j <= 10; j++) {
            if (a[i][j] == '#') {
                if (a[i - 1][j] == '#') {
                    dp[i][j] = dp[i - 1][j] + 1;
                } else if (a[i][j - 1] == '#') {
                    dp[i][j] = dp[i][j - 1] + 1;
                } else {
                    dp[i][j] = 1;
                }
            }
        }
    }
    vector<int> res(11, 0);
    for (int i = 1; i <= 10; i++) {
        for (int j = 1; j <= 10; j++) {
            res[dp[i][j]]++;
        }
    }
    vector<int> ans(11, 0);
    ans[0] = 80;
    ans[1] = 10;
    ans[2] = 6;
    ans[3] = 3;
    ans[4] = 1;
    for (int i = 0; i <= 10; i++) {
        if (ans[i] == res[i]) {
            continue;
        } else {
            cout << "NO\n";
            return 0;
        }
    }
    cout << "YES\n";
}
