#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

//#pragma GCC optimize("O3,Ofast,unroll-loops")
//#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> pair_) {
    in >> pair_.first >> pair_.second;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> pair_) {
    out << pair_.first << " " << pair_.second;
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &arr_) {
    for (auto &_: arr_) {
        in >> _;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr_) {
    for (auto &_: arr_) {
        out << _ << " ";
    }
    return out;
}

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//#define int ll

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define many int _; cin >> _; while(_--)
#define endl "\n";

set<pii> s;
unordered_map<int, int> l_sz, r_sz;

void add(int l, int sz) {
    int r = l + sz - 1;
    s.insert({sz, l});
    l_sz[l] = sz;
    r_sz[r] = sz;
}

void del(int l, int sz) {
    int r = l + sz - 1;
    s.erase({sz, l});
    l_sz.erase(l);
    r_sz.erase(r);
}

int main() {
    int n, q;
    cin >> n >> q;

    s = {{n, 0}};
    l_sz[0] = n;
    r_sz[n - 1] = n;

    vector<int> inds(q);
    int cnt = 0;
    for (int i = 0; i < q; i++) {
        char type;
        cin >> type;
        if (type == '+') {
            auto it = s.end();
            it--;
            auto [sz, l] = *it;
            int r = l + sz - 1;
            del(l, sz);
            int ind;
            if (l == 0) {
                ind = 0;
                add(1, sz - 1);
            } else if (r == n - 1) {
                ind = n - 1;
                add(l, sz - 1);
            } else {
                ind = l + ((sz - 1) / 2);
                int new_sz1 = ind - l, new_sz2 = r - ind;
                add(l, new_sz1);
                add(ind + 1, new_sz2);
            }
            cout << ind + 1 << endl;
            inds[cnt] = ind;
            cnt++;
        } else {
            int x;
            cin >> x;
            x--;
            int ind = inds[x];
            if (ind == 0) {
                int sz = l_sz[1];
                del(1, sz);
                add(0, sz + 1);
            } else if (ind == n - 1) {
                int sz = r_sz[n - 2];
                int l = n - sz;
                del(l, sz);
                add(l, sz + 1);
            } else {
                int sz1 = r_sz[ind - 1];
                int l1 = ind - sz1;
                del(l1, sz1);
                int sz2 = l_sz[ind + 1];
                del(ind + 1, sz2);
                add(l1, sz1 + sz2 + 1);
            }
        }
    }
}
