#include <bits/stdc++.h>
#define ld long double

using namespace std;

#define int int64_t

const int INF = 2e9;

vector<int> h;
vector<int> c;

int n;

vector<pair<int,int>> segTree;

void build(int l,int r,int indV)
{
    if(l == r)
    {
        segTree[indV] = {h[l],l};
        return ;
    }
    int m = (l+r)/2;
    build(l,m,indV*2+1);
    build(m+1,r,indV*2+2);
    segTree[indV] = max(segTree[indV*2+1],segTree[indV*2+2]);
    return ;
}
pair<int,int> get(int lx,int rx,int l,int r,int indV)
{
    if(l > rx || r < lx)
        return {-1,-1};
    else if(l >= lx && r <= rx)
        return segTree[indV];
    int m= (l+r)/2;
    pair<int,int> sl = get(lx,rx,l,m,indV*2+1);
    pair<int,int> sr=  get(lx,rx,m+1,r,indV*2+2);
    return max(sl,sr);
}

int64_t rec(int l,int r)
{
    if(l > r)
        return 0;
    pair<int,int> cc = get(l,r,0,n-1,0);
    int tc = cc.second;
    return min({c[tc] + rec(l,tc-1),c[tc] + rec(tc+1,r)});
}

signed main()
{
    //int n;
    cin >> n;
    segTree.resize(4*n);
    h.resize(n);
    c.resize(n);
    for(int i = 0;i < n;++i)
    {
        cin >> h[i];
    }
    build(0,n-1,0);
    for(int j = 0;j < n;++j)
    {
        cin >> c[j];
    }
    cout << rec(0,n-1);
}
