#include <iostream>
#include <vector>
using namespace std;

int n;
int abc[12][12];
int use[10][10];
int ships[5];

int search(int i, int y) {
    use[i][y] = 1;
    if (abc[i+1][y-1] == 1 || abc[i+1][y+1] == 1 || abc[i-1][y+1] == 1 || abc[i-1][y-1] == 1) {
        return -1;
    }
    else {
        if (abc[i][y-1] == 1) {
            if (search(i, y-1) == -1) {
                return -1;
            }
            return 1;
        }
        if (abc[i+1][y] == 1) {
            if (search(i+1, y) == -1) {
                return -1;
            }
            return 1;
        }
    }
    return 1;
}

int main() {
    for (int i = 0; i < 12; i++) {
        for (int y = 0; y < 12; y++) {
            if (i > 0 && i < 11 && y > 0 && y < 11) {
                char temp; cin >> temp;
                if (temp == '#') {
                    abc[i][y] = 1;
                }
                else {
                    abc[i][y] = 0;
                }
            }
            else {
                abc[i][y] = 0;
            }
        }
    }

    for (int i = 1; i < 11; i++) {
        for (int y = 1; y < 11; y++) {
            if (abc[i][y] == 1 && use[i-1][y-1] == 0) {
                if (search(i, y) == -1) {
                    cout << "NO\n";
                    return 0;
                }
            } 
        }
    }
    cout << "YES\n";
    return 0;
}