/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<int, double> pid;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, m)
    in(double, r)
    unordered_map<int, double> inc;
    for (int i = 0; i < n; i++) {
        in(int, d)
        in(double, w)
        inc[d] = w;
    }

    cout.precision(12);
    for (int i = 0; i < m; i++) {
        in(int, q)
        double value = 0;
        for (int day = 1; day <= q; day++) {
            value = (1 - r) * value;
            if (inc.count(day)) {
                value += r * inc[day];
            }
        }
        cout << value << ' ';
    }
    cout << '\n';

}